#include <iostream>
#include <fstream>
#include <LEDA/graphics/graphwin.h>
#include <LEDA/graph/graph.h>
#include <LEDA/graph/edge_array.h>
#include <LEDA/graph/node_array.h>

using namespace std;
using namespace leda;

#define CHIMEI 30
#define N 56
#define SIZE 500

void input(double A[SIZE][SIZE],char B[N][CHIMEI]); //入力
void R(double A[SIZE][SIZE],double C[SIZE],int *); // Rを求める関数。
void D(double A[SIZE][SIZE],double C[SIZE],double *,int *,int *,int *);
void kousin(double A[SIZE][SIZE],int *,int *,int *); //距離表の更新


int main()
{

  double A[SIZE][SIZE],C[SIZE],da,db,min;
  char B[N][CHIMEI];
  int i,j,k,di,dj,index,num=0;
  //random_source s,s1;

  input(A,B);

  GRAPH<int,double> G;
  array<node> v(SIZE);

  for(i=0;i<N;i++)
    v[i] = G.new_node();

  index = i;

  for(k=0;k<N-2;k++){
    min=0;di=0;dj=0;
    R(A,C,&num);
    D(A,C,&min,&di,&dj,&num);

    num++;

    da=(((A[di][dj]+C[di])-C[dj])/2);
    db=A[di][dj]-da;
    //cout<<B[di]<<' '<<B[dj]<<endl;
    //cout<<di<<' '<<dj<<' '<<A[di][dj]<<' '<<C[di]<<' '<<C[dj]<<' '<<da<<' '<<db<<endl;
    // cout << di << " " << dj << endl;

    kousin(A,&di,&dj,&num);
    
    v[index] = G.new_node();
    
    edge eg;
    eg = G.new_edge(v[index],v[di],da);
    eg = G.new_edge(v[index],v[dj],db);
    
    index++;
    //G.write("nj.gw");
  }

  // 最後に2つのグラフを結合
  
  min=0;di=0;dj=0;
  R(A,C,&num);
  D(A,C,&min,&di,&dj,&num);
  
  
  edge eg;
  eg = G.new_edge(v[di],v[dj],A[di][dj]);
  
  //G.write("nj-sample.gw");
  //*/
  
  //グラフの設定

  GraphWin gw(G,800,800,"nj-56");
  gw.set_node_color(red);
  gw.set_edge_direction(undirected_edge);
  
  
  for(i=0;i<N;i++){
    gw.set_label(v[i],B[i]);
    gw.set_shape(v[i],rectangle_node);

   //***************地域によっての色分け*****************

    if(strcmp(B[i],"hokkaido1")==0 || strcmp(B[i],"hokkaido2")==0)
      gw.set_color(v[i],red);
    else if(strcmp(B[i],"aomori")==0 || strcmp(B[i],"iwate1") ==0 || strcmp(B[i],"iwate2")==0 || strcmp(B[i],"akita")==0 || strcmp(B[i],"miyagi")==0 || strcmp(B[i],"fukushima")==0 || strcmp(B[i],"yamagata")==0 )
      gw.set_color(v[i],green);
    else if(strcmp(B[i],"tochigi")==0 || strcmp(B[i],"gunma")==0 || strcmp(B[i],"ibaraki")==0 || strcmp(B[i],"chiba1")==0 || strcmp(B[i],"chiba2")==0 || strcmp(B[i],"tokyo")==0 || strcmp(B[i],"kanagawa")==0 || strcmp(B[i],"nhk")==0)
      gw.set_color(v[i],blue);
    else if(strcmp(B[i],"aichi")==0 || strcmp(B[i],"shizuoka1")==0 || strcmp(B[i],"shizuoka2")==0 || strcmp(B[i],"nagano2")==0 || strcmp(B[i],"nigata1")==0 || strcmp(B[i],"nigata2")==0 || strcmp(B[i],"toyama")==0 || strcmp(B[i],"gifu")==0 || strcmp(B[i],"ishikawa")==0 || strcmp(B[i],"yamanashi")==0 || strcmp(B[i],"nagano1")==0)
      gw.set_color(v[i],yellow);
    else if(strcmp(B[i],"kyoto")==0 || strcmp(B[i],"hyogo1")==0 || strcmp(B[i],"hyogo2")==0 || strcmp(B[i],"osaka")==0 || strcmp(B[i],"wakayama")==0 || strcmp(B[i],"nara")==0 || strcmp(B[i],"mie")==0)
      gw.set_color(v[i],pink);
    else if(strcmp(B[i],"hiroshima")==0 || strcmp(B[i],"shimane")==0 || strcmp(B[i],"okayama")==0 || strcmp(B[i],"yamaguchi")==0)
      gw.set_color(v[i],orange);
    else if(strcmp(B[i],"kouchi1")==0 || strcmp(B[i],"kouchi2")==0 || strcmp(B[i],"kagawa1")==0 || strcmp(B[i],"kagawa2")==0 || strcmp(B[i],"tokushima")==0 || strcmp(B[i],"ehime")==0)
      gw.set_color(v[i],violet);
    else if(strcmp(B[i],"fukuoka")==0 || strcmp(B[i],"saga")==0 || strcmp(B[i],"kumamoto1")==0 || strcmp(B[i],"kumamoto2")==0 || strcmp(B[i],"oita")==0 || strcmp(B[i],"miyazaki")==0 || strcmp(B[i],"nagasaki1")==0 || strcmp(B[i],"nagasaki2")==0 || strcmp(B[i],"kagoshima")==0)
      gw.set_color(v[i],cyan);
    else if(strcmp(B[i],"nakijin")==0 || strcmp(B[i],"naha")==0)
      gw.set_color(v[i],ivory);

    gw.set_width(v[i],45);
    gw.set_height(v[i],15);
    // point p(s1(),s1());
    //gw.set_position(v[i],p);
  }
  
  for(i=N;i<index;i++){
    gw.set_label(v[i]," ");
    gw.set_width(v[i],2);
    gw.set_height(v[i],2);
    //point p(s1(),s1());
    //gw.set_position(v[i],p);
  }
  gw.open();
  
  return 0;
}

//ファイル入出力。距離表を作る。

void input (double A[SIZE][SIZE],char B[N][CHIMEI]){

  int i,j;

  ifstream fin;
  ofstream fout;

  fin.open("fileout");

  for(i=0;i<N;i++)
    for(j=0;j<N;j++){
      if(i==j)
	A[i][j]=0;
      else{
	fin>>B[N];
	fin>>A[i][j];
      }
    }

  fin.close();
  
  fin.open("filename");

  for(i=0;i<N;i++)
    fin >> B[i];

  fin.close();

  /*
  //距離表を出力する

  fout.open("momotaro-56-out.csv");

  for(i=0;i<=N;i++){
    for(j=0;j<=N;j++){
      if(i==0 && j==0)
	fout << '"' << ' ' << '"' << ',';
      else if(i==0)
	fout << '"' << B[j-1]<< '"'<< ',';
      else if(j==0)
	fout << '"' << B[i-1]<< '"'<< ',';
      else
	fout << '"' << A[i-1][j-1] << '"' << ',';
    }
    fout << endl;
  }
  fout.close();
  */

}

// Rを求める関数。

void R(double A[SIZE][SIZE],double C[SIZE],int *num){
  int i,j;

  for(i=0;i<N+*num;i++){
    C[i]=0;
    for(j=0;j<N+*num;j++){
      C[i]+=A[i][j];
      // cout <<i<<' '<<j<<' ' <<C[i]<<endl;
    }
    C[i]=C[i]/((N-*num)-2);
  }
}

//最小のペアを求める

void D(double A[SIZE][SIZE],double C[SIZE],double *min,int *di,int *dj,int *num){
  int i,j;
  double d;

  for(i=0;i<N+*num;i++)
    for(j=0;j<N+*num;j++){
      if(A[i][j]!=0){
	d=A[i][j]-(C[i]+C[j]);
	if(*min>d){
	  *min=d;*di=i;*dj=j;
	}
      }
    }
}

 //距離表の更新

void kousin(double A[SIZE][SIZE],int *di,int *dj,int *num){

  int i,j;

  for(i=0;i<N+*num;i++)
    if(A[*di][i]!=0 && A[*dj][i] && A[*di][*dj]){
    A[i][N+*num-1]=(A[*di][i]+A[*dj][i]-A[*di][*dj])/2;
    A[N+*num-1][i]=A[i][N+*num-1];
  }
      A[N+*num-1][N+*num-1]=0;
  

  for(i=0;i<N+*num;i++)
    for(j=0;j<N+*num;j++){
      if(i==*di || i==*dj || j==*di || j==*dj)
	A[i][j]=0;
    }
  // cout << *num << endl;
  /*
  for(i=0;i<N+*num;i++){
    for(j=0;j<N+*num;j++){
      if(A[i][j] != 0)
	printf("x ");
      else
	printf("0 ");
    }
    putchar('\n');
  }
  putchar('\n');
  */

}
